/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Offline教材 オフラインログのcmi-objectivesタグデータ保持クラス
//			変更履歴
//				2004.01.08	新規作成	二條　智文
//
package jp.co.ntt.lms.lo.Offline.OfflineLog;

import org.w3c.dom.*;
import java.util.*;

/**
 * Offline教材 オフラインログのcmi-objectivesタグデータ保持クラス<BR>
 * オフラインログのcmi-objectivesノードを受け取り、自身の内部変数にデータを
 * 格納します。
 */
public class OfflineCmiObjectives implements OfflineLogConst {

	// 自身のノードオブジェクトを保持します。
	private Element mobjObjectivesElm = null;

	// エラーメッセージ
	private static final String ERR_PRE = "<loms>-<lom>-<cmi>-<objectives>:";
	private static final String ERR_NOT_OBJECTIVES = ERR_PRE + "objectivesタグではありません。";
	private static final String ERR_NOEXIST_INUMBER = ERR_PRE + "i数字 タグが存在しません。";

	// <cmi>-<objectives>-<i数字>エレメントデータを保持します。
	private Vector mvecObjectivesLog = new Vector();

	/**
	 * コンストラクタです。
	 * @param objNode cmi-objectivesエレメントオブジェクト
	 * @exception OfflineLogParseException パースエラー
	 */
	OfflineCmiObjectives( Element objElement )
		throws OfflineLogParseException
	{
		// タグ名のチェック
		String strTagName = objElement.getTagName();
		if( strTagName == null || !strTagName.equals( LOM_OBJECTIVES ) ) {
			throw new OfflineLogParseException( ERR_NOT_OBJECTIVES );
		}

		mobjObjectivesElm = objElement;

		parse();

	}

	/**
	 * <cmi>-<objectives>-<i数字>エレメントデータの長さを取得します。
	 * @return int 長さ
	 */
	public int getObjectivesLogLength() {
		return mvecObjectivesLog.size();
	}

	/**
	 * 指定されたインデックスの<cmi>-<objectives>-<i数字>エレメントデータを取得します。
	 * @return OfflineCmiObjectivesLog
	 */
	public OfflineCmiObjectivesLog getObjectivesLog( int index ) {
		return (OfflineCmiObjectivesLog)mvecObjectivesLog.get(index);
	}


//------------------------------------ 内部関数 --------------------------------
	/**
	 * コンストラクタで受け取ったエレメントないのデータを
	 * 取得して、自身の変数に格納します。
	 */
	private void parse()
		throws OfflineLogParseException
	{

		// <cmi>-<objectives>-<i数字>エレメントデータの設定
		NodeList objLogList = mobjObjectivesElm.getChildNodes();

		for( int i = 0; i < objLogList.getLength(); i++ ) {

			Node objNodeTemp = objLogList.item( i );

			String strNodeTitle = objNodeTemp.getNodeName();

			// ノード名が'i'で始まるノードを探す
			if( strNodeTitle.charAt(0) == LOM_OBJECTIVES_PRE ) {

				// 'i' の次の文字が数字のものを探す
				try {
					String strNum = strNodeTitle.substring( 1, strNodeTitle.length() );

					// 数値に変換する。
					int intNum = Integer.parseInt( strNum );

					mvecObjectivesLog.add( new OfflineCmiObjectivesLog( (Element)objNodeTemp ) );
				}
				catch( NumberFormatException ne ) {}
				catch( IndexOutOfBoundsException  ie ) {}
			}
		}

		// 1件も存在しなかったらエラーとする
		if( mvecObjectivesLog.size() == 0 ) {
			throw new OfflineLogParseException( ERR_NOEXIST_INUMBER );
		}

	}
//------------------------------------ 内部関数 --------------------------------
}

